/*
 * File Name : dvm.h
 *
 * Description : Define the data structure for the task execution
 *               environment data. This structure contains all 
 *	         task information and is created by CVM and is sent
 *               DVM by CVM through the specified socket.
 *
 * Programmed by : Ilkyeun Ra, Syracuse University
 *
 * Date : December 15, 1996
 *
 * Update history :
 *
*/

#include <sys/param.h>

/*
 * Define for data types
*/
#define File      0
#define Integer   1
#define Char      2
#define Float     3
#define Structure 4

/* Task table for transfering data between tasks */
struct task {
  int user_id;
  int appl_id;

  char v_name[MAXPATHLEN];  /* name of data */
  int  v_type;              /* Type of data : need to modify       
  		             * 0 : file
			     * 1 : integer
			     * 2 : char
			     * 3 : float
			     * 4 : structure
			    */
  char s_name[MAXPATHLEN];  /* source hostname */
  int  s_pid;	            /* source port id */
  int  s_port;              /* source data port number */
  int  s_tkid;              /* source task id */
  int  s_socket;            /* source socket descriptor */
  int  s_data_rep;	    /* source data representation */
  char d_name[MAXPATHLEN];  /* destination hostname */
  int  d_pid;	            /* destination port id */
  int  d_port;              /* destination data port number */
  int  d_tkid;              /* destination task id */
  int  d_socket;            /* destination socket descriptor */
  int  d_data_rep;	    /* destination data representation */

}; /* end of define task structure */

typedef struct {
  int proc;
  int msgtype;
  int size;
} VDCE_HEADER;


#define         VDCERECV        0
#define         VDCESEND        1

